# killercoda-cli

[![PyPI - Version](https://img.shields.io/pypi/v/killercoda-cli.svg)](https://pypi.org/project/killercoda-cli)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/killercoda-cli.svg)](https://pypi.org/project/killercoda-cli)

---

**Table of Contents**


1. [Installation](#installation)
2. [Usage](#usage)
   * [Requirements:](#requirements:)
   * [Functionality:](#functionality:)
   * [Example:](#example:)
3. [License](#license)

## Installation

```console
pip install killercoda-cli
```

## Usage

### Requirements:

- The tool must be run in a directory containing step files or directories (e.g., step1.md, step2/).
- An 'index.json' file must be present in the directory, which contains metadata about the steps.

### Functionality:

- Renames and renumbers step files and directories based on user input.
- Updates the 'index.json' file to reflect changes in step order and titles.

### Example:

Suppose you have a scenario directory with the following structure:

    .
    ├── index.json
    ├── step1.md
    └── step2
        └── step2.md

And you want to insert a new step between 'step1.md' and 'step2/', titled "New Step".

1. Run 'killercoda-cli'.
2. Enter the title for the new step: "New Step".
3. Enter the step number to insert the new step at: 2.

After running the tool, your directory structure will be updated to:

    .
    ├── index.json
    ├── step1.md
    ├── step2
        └── step2.md (previously step1.md content)
    └── step3
        └── step3.md (previously step2.md content)

The `index.json` file will also be updated to include the new step and renumber existing steps accordingly.

Before:

```json
{
  "steps": [
    {
      "title": "Step 1",
      "text": "step1.md"
    },
    {
      "title": "Step 2",
      "text": "step2/step2.md"
    }
  ]
}
```

After:

```json
{
  "steps": [
    {
      "title": "Step 1",
      "text": "step1.md"
    },
    {
      "title": "New Step",
      "text": "step2/step2.md"
    },
    {
      "title": "Step 2",
      "text": "step3/step3.md"
    }
  ]
}
```

> [!NOTE]
>
> The tool automatically handles the renaming of directories and files, ensuring a smooth workflow for scenario development and updates.

## License

`killercoda-cli` is distributed under the terms of the [MIT](https://spdx.org/licenses/MIT.html) license.
